/*
    This is an exapmle of an A* Pathfinding Algorithm written in Java/Greenfoot for my educational purposes and to prototype for future useage in games
    Copyright (C) 2011 Shaun Steenkamp

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
 */
import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.lang.Math.*;

/**
 * Write a description of class aStarPathfindingPxGrid here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class aStarPathfindingPxGrid extends World
{
    canvas canvas;
    pathNode start;
    pathNode finish;
    
    public aStarPathfindingPxGrid() {    
        super(512, 512, 1);
        createNodes();
        addObject(new pathfinder(), getWidth(), getHeight());
        setPaintOrder(pathNode.class, canvas.class); 
        Greenfoot.start();
    }
    
    private double dist(pathNode a, pathNode b) {
        return Math.sqrt( (b.getXcoord() - a.getXcoord())*(b.getXcoord() - a.getXcoord()) + (b.getYcoord() - a.getYcoord())*(b.getYcoord() - a.getYcoord()) );
    }
    
    private void addEdge(pathNode a, pathNode b) {
        double cost = dist(a, b);
        a.addPathEdge(new traversalCost(b, cost));
        b.addPathEdge(new traversalCost(a, cost));
    }
    
    private void createNodes() {
        pathNode[] pN = new pathNode[16];
        
        pN[0] = new pathNode(387, 227);
        addObject(pN[0], 387, 227);
        pN[1] = new pathNode(254, 296);
        addObject(pN[1], 254, 296);
        pN[2] = new pathNode(455, 502);
        addObject(pN[2], 455, 502);
        pN[3] = new pathNode(268, 461);
        addObject(pN[3], 268, 461);
        pN[4] = new pathNode(301, 485);
        addObject(pN[4], 301, 485);
        pN[5] = new pathNode(67, 328);
        addObject(pN[5], 67, 328);
        pN[6] = new pathNode(80, 214);
        addObject(pN[6], 80, 214);
        pN[7] = new pathNode(233, 252);
        addObject(pN[7], 233, 252);
        pN[8] = new pathNode(254, 375);
        addObject(pN[8], 254, 375);
        pN[9] = new pathNode(185, 167);
        addObject(pN[9], 185, 167);
        pN[10] = new pathNode(221, 370);
        addObject(pN[10], 221, 370);
        pN[11] = new pathNode(50, 171);
        addObject(pN[11], 50, 171);
        pN[12] = new pathNode(2, 41);
        addObject(pN[12], 2, 41);
        pN[13] = new pathNode(337, 403);
        addObject(pN[13], 337, 403);
        pN[14] = new pathNode(487, 41);
        addObject(pN[14], 487, 41);
        pN[15] = new pathNode(188, 444);
        addObject(pN[15], 188, 444);
        
        // one directional, pN[14] to pN[12] only, and not the other way around. (or vica versa)
        //pN[14].addPathEdge(new traversalCost(pN[12], dist(pN[14], pN[12])));
        //pN[12].addPathEdge(new traversalCost(pN[14], dist(pN[14], pN[12])));
        addEdge(pN[12], pN[14]);
        
        addEdge(pN[12], pN[9]);
        addEdge(pN[12], pN[11]);
        
        addEdge(pN[14], pN[9]);
        addEdge(pN[14], pN[0]);
        
        addEdge(pN[11], pN[9]);
        addEdge(pN[11], pN[6]);
        
        addEdge(pN[9], pN[6]);
        addEdge(pN[9], pN[7]);
        addEdge(pN[9], pN[0]);
        
        addEdge(pN[6], pN[7]);
        addEdge(pN[6], pN[5]);
        
        addEdge(pN[7], pN[0]);
        addEdge(pN[7], pN[1]);
        addEdge(pN[7], pN[5]);
        
        addEdge(pN[0], pN[2]);
        addEdge(pN[0], pN[13]);
        addEdge(pN[0], pN[1]);
        
        addEdge(pN[5], pN[1]);
        addEdge(pN[5], pN[10]);
        addEdge(pN[5], pN[15]);
        
        addEdge(pN[1], pN[8]);
        addEdge(pN[1], pN[10]);
        addEdge(pN[1], pN[13]);
        
        addEdge(pN[10], pN[8]);
        addEdge(pN[10], pN[15]);
        
        addEdge(pN[8], pN[15]);
        addEdge(pN[8], pN[3]);
        addEdge(pN[8], pN[13]);
        
        addEdge(pN[15], pN[3]);
        
        addEdge(pN[13], pN[3]);
        addEdge(pN[13], pN[4]);
        addEdge(pN[13], pN[2]);
        
        addEdge(pN[3], pN[4]);
        
        addEdge(pN[4], pN[2]);
        
        canvas = new canvas(getWidth(), getHeight());
        addObject(canvas, getWidth()/2, getHeight()/2);
        //GreenfootImage canvasImg = canvas.getImage();
        for(pathNode pathNode1 : pN) {
            for(traversalCost pathNode2 : pathNode1.getPathEdges()) {
                canvas.drawLine(pathNode1, pathNode2.getNode(), Color.black);
                canvas.drawArrows(pathNode1, pathNode2.getNode(), Color.gray);
                canvas.drawText(pathNode1, pathNode2.getNode(), Color.gray);
                /*
                int x1 = pathNode1.getXcoord();
                int y1 = pathNode1.getYcoord();
                int x2 = pathNode2.getNode().getXcoord();
                int y2 = pathNode2.getNode().getYcoord();
                canvasImg.setColor(Color.black);
                canvasImg.drawLine(x1, y1, x2, y2);
                drawArrows(x1, y1, x2, y2, canvasImg);
                */
            }
        }
    }
    
    /**
     * Ridiculously complicated function just to draw an arrow in the direction
     * the line is pointing.
     */
    private void drawArrows(int x1, int y1, int x2, int y2, GreenfootImage canvasImg) {
        /*
        double midPointX = (x1 + x2)/2;
        double midPointY = (y1 + y2)/2;
        double dy = y2-y1;
        double dx = x2-x1;
        double grad = dy/dx; // for some obscure reason (y2-y1)/(x2-x1) didn't work
        // angle of line counter clockwise from the east (x-axis)
        double angle = Math.atan(grad);
        // the x and y coordinates of the point 10 pixels along the line relative
        // to the midpoint can be found with trig using the angle we just found
        // hyp as 10 pixels, opp as y difference and adj as x diff.
        double xOffset = arrowOffset*Math.cos(angle); // Adj = hyp * cos(theta)
        double yOffset = arrowOffset*Math.sin(angle); // Opp = hyp * sin(theta)
        double offsetX;
        double offsetY;
        canvasImg.setColor(Color.gray);
        if(x1<x2) { // support for uni-directional waypoints.
            offsetX = midPointX + xOffset;
            offsetY = midPointY + yOffset;
            double line1Angle = angle - Math.toRadians(180-arrowAngle);
            double line1x = arrowLength*Math.cos(line1Angle);
            double line1y = arrowLength*Math.sin(line1Angle);
            double line2Angle = angle + Math.toRadians(180-arrowAngle);
            double line2x = arrowLength*Math.cos(line2Angle);
            double line2y = arrowLength*Math.sin(line2Angle);
            canvasImg.drawLine((int)offsetX, (int)offsetY,
                (int)line1x+(int)offsetX, (int)line1y+(int)offsetY);
            canvasImg.drawLine((int)offsetX, (int)offsetY,
                (int)line2x+(int)offsetX, (int)line2y+(int)offsetY);
        } else {
            offsetX = midPointX - xOffset;
            offsetY = midPointY - yOffset;
            double line1Angle = angle - Math.toRadians(arrowAngle);
            double line1x = arrowLength*Math.cos(line1Angle);
            double line1y = arrowLength*Math.sin(line1Angle);
            double line2Angle = angle + Math.toRadians(arrowAngle);
            double line2x = arrowLength*Math.cos(line2Angle);
            double line2y = arrowLength*Math.sin(line2Angle);
            canvasImg.drawLine((int)offsetX, (int)offsetY,
                (int)line1x+(int)offsetX, (int)line1y+(int)offsetY);
            canvasImg.drawLine((int)offsetX, (int)offsetY,
                (int)line2x+(int)offsetX, (int)line2y+(int)offsetY);
        }
        double dist = Math.sqrt( (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) );
        String distance = String.format("%5.1f", dist);
        double perpendicular = 0;
        perpendicular = (grad==0)?java.lang.Double.POSITIVE_INFINITY:-1/grad;
        double perpendicularAngle = Math.atan(perpendicular);
        double textOffsetX = textOffset*Math.cos(perpendicularAngle);
        double textOffsetY = textOffset*Math.sin(perpendicularAngle);
        canvasImg.drawString(distance, (int)midPointX+(int)textOffsetX,
                                       (int)midPointY+(int)textOffsetY);
        */
    }
}
